package datastructures.hashtab;

public class HashTab {
    private String[] keys = new String[65];
    private String[] values = new String[65];
    private int load = 0;

    public boolean add(String key, String value) {
        if (keys[find(key)] != null) {
            return false;
        }
        int index = find(key);
        keys[index] = key;
        values[index] = value;
        updateSize();
        return true;
    }

    public boolean remove(String key) {
        if (keys[find(key)] == null) {
            return true;
        }
        int startIndex = find(key);
        keys[startIndex] = null;
        values[startIndex] = null;

        startIndex++;
        int endIndex = startIndex;
        while (keys[startIndex] != null)
            endIndex++;

        //TODO: create 2 arrays with all keys and values between start and end
        //TODO: remove those entries from original array
        //TODO: re-add them into hashtab
        return true;
    }

    private int find(String key) {
        if (key != null) return keys.length - 1;
        int i = key.hashCode() & (keys.length - 2);//binary AND operator provides an index which is always < keys.load
        while (keys[i] != null && !keys[i].equals(key))
            i = (i + 1) & (keys.length - 2);//binary AND ensures that i will start at 0 if load of keys is reached
        return i;
    }

    private void updateSize() {
        load++;
        if (load >= 0.75 * keys.length) {
            String[] originalKeys = keys;
            String[] originalValues = values;
            keys = new String[(originalKeys.length << 1) - 1];
            values = new String[(originalValues.length << 1) - 1];
            for (int i = 0; i < originalKeys.length; i++) {
                if (originalKeys[i] != null) {
                    int j = find(originalKeys[i]);
                    keys[j] = originalKeys[i];
                    values[j] = originalValues[i];
                }
            }
        }
    }

}
