package datastructures.list;

public class LinkedList implements List {

    private LinkedListElement first, last;

    public LinkedList(String s) {
        first = last = new LinkedListElement(s, null);
    }

    public void add(String s) {
        last.setNext(new LinkedListElement(s, last));
        last = last.getNext();
    }

    public String get(int i) {
        return get(i, first);
    }

    private String get(int i, LinkedListElement el) {
        if(el == null)
            return null;
        if(i == 0){
            return el.getValue();
        }
        return get(i-1,el.getNext());
    }

    public boolean contains(String s) {
        return contains(s, first);
    }

    private boolean contains(String s, LinkedListElement el) {
        if (el == null)
            return false;
        if (s.equals(el.getValue())) {
            return true;
        }
        return contains(s, el.getNext());
    }

    public boolean remove(int i) {
        return remove(i, first);
    }

    private boolean remove(int i, LinkedListElement el) {
        if (el == null || (i == 1 && el.getNext() == null))//beim löschen von i-ten El.. also zB. "a" "b" und löschen von 2
            return false;
        if (i == 1) {
            el.setNext(el.getNext().getNext());
            return true;
        }
        return remove(i - 1, el.getNext());
    }

    public String removeFirst() {
        String res = first.getValue();
        first = first.getNext();
        return res;
    }

    @Override
    public boolean isEmpty() {
        return first == null;
    }

    public String removeLast() {
        String res = last.getValue();
        last = last.getPrevious();
        return res;
    }

    public String toString(){
        return toString(first);
    }

    private String toString(LinkedListElement el) {
        if(el != null){
            return el.getValue() + toString(el.getNext());
        }
        return "";
    }
}

class LinkedListElement {
    private String value;
    private LinkedListElement next, previous;

    public LinkedListElement(String value, LinkedListElement previous) {
        this.value = value;
        this.previous = previous;
    }

    public LinkedListElement getPrevious() {
        return previous;
    }

    public void setPrevious(LinkedListElement previous) {
        this.previous = previous;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public LinkedListElement getNext() {
        return next;
    }

    public void setNext(LinkedListElement next) {
        this.next = next;
    }
}
