package datastructures.list;

public class RingList implements List {
    private RingListElement firstElement;//will always be a placeholder

    public RingList() {
        this.firstElement = new RingListElement(null, null);
        firstElement.setNext(firstElement);
    }

    public void add(String s) {
        firstElement.setValue(s);
        firstElement.setNext(firstElement = new RingListElement(null, firstElement.getNext()));
    }

    public String seeFirst(){
        return firstElement.getNext().getValue();
    }

    public String removeFirst(){
        String res = firstElement.getNext().getValue();//always call .getNext() to get the first element
        firstElement.setNext(firstElement.getNext().getNext());
        return res;
    }

    public boolean contains(String s) {
        RingListElement el = firstElement.getNext();
        while (el != firstElement && !s.equals(el.getValue())) {
            el = el.getNext();
        }
        return el != firstElement;
    }

    public boolean isEmpty(){
        return firstElement.getNext() == firstElement;
    }
}

class RingListElement {
    private String value;
    private RingListElement next;

    public RingListElement(String value, RingListElement next) {
        this.value = value;
        this.next = next;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public RingListElement getNext() {
        return next;
    }

    public void setNext(RingListElement next) {
        this.next = next;
    }
}
