package datastructures.queue;

public class DEQueue {
    private DEQueueElement firstElement;
    private DEQueueElement lastElement;

    public DEQueue(int i) {
        firstElement = lastElement = new DEQueueElement(i,null);
    }

    public void addFirst(int value) {
        DEQueueElement el = new DEQueueElement(value, null);
        el.setNext(firstElement);
        firstElement.setPrevious(el);
        firstElement = el;
    }

    public void addLast(int value) {
        DEQueueElement el = new DEQueueElement(value, lastElement);
        el.setPrevious(lastElement);
        lastElement.setNext(el);
        lastElement = el;
    }

    public DEQueueElement peekFirst() {
        return firstElement;
    }

    public DEQueueElement peekLast() {
        return lastElement;
    }

    public DEQueueElement pollFirst() {
        DEQueueElement el = firstElement;
        firstElement = firstElement.getNext();
        firstElement.setPrevious(null);
        return el;
    }

    public DEQueueElement pollkLast() {
        DEQueueElement el = lastElement;
        lastElement = lastElement.getPrevious();
        lastElement.setNext(null);
        return el;
    }

}

class DEQueueElement {
    private int value;
    private DEQueueElement next, previous;

    public DEQueueElement(int value, DEQueueElement previous) {
        this.value = value;
        this.previous = previous;
    }

    public DEQueueElement getNext() {
        return next;
    }

    public void setNext(DEQueueElement next) {
        this.next = next;
    }

    public int getValue() {
        return value;
    }

    public void setValue(int value) {
        this.value = value;
    }

    public DEQueueElement getPrevious() {
        return previous;
    }

    public void setPrevious(DEQueueElement previous) {
        this.previous = previous;
    }
}
