package datastructures.queue;

public class Queue {
    private QueueELement queueStart;
    private QueueELement queueLast;

    public Queue(int value) {
        queueStart = queueLast = new QueueELement(value, null);
    }

    public void add(int value) {
        if (queueStart == null) {
            return;
        } else {
            queueLast.setNext(new QueueELement(value, null));
            queueLast = queueLast.getNext();
        }
    }

    public int peek() {
        if (queueStart != null)
            return queueStart.getValue();
        return Integer.MIN_VALUE;
    }

    public int poll() {
        if (queueStart != null) {
            int res = queueStart.getValue();
            queueStart = queueStart.getNext();
            return res;
        }
        return Integer.MIN_VALUE;
    }
}

class QueueELement {
    private int value;
    private QueueELement next;

    public QueueELement(int value, QueueELement next) {
        this.value = value;
        this.next = next;
    }

    public int getValue() {
        return value;
    }

    public void setValue(int value) {
        this.value = value;
    }

    public QueueELement getNext() {
        return next;
    }

    public void setNext(QueueELement next) {
        this.next = next;
    }
}
