package datastructures.stack;

public class Stack {
    private StackElement stack;

    public void add(int value) {
        if (stack == null) {
            stack = new StackElement(null, value);
            return;
        } else {
            StackElement newStack = new StackElement(stack, value);
            stack = newStack;
        }
    }

    public int peek() {
        return stack.getValue();
    }

    public int pop() {
        int res = stack.getValue();
        stack = stack.getNext();
        return res;
    }

    public void increment(){
        increment(stack);
    }

    private void increment(StackElement stack) {
        while (stack!=null){
            stack.setValue(stack.getValue()+1);
            increment(stack.getNext());
        }
    }

}

class StackElement {
    private int value;
    private StackElement next;//element after this element on datastructures.stack

    public StackElement(StackElement next, int value) {
        this.next = next;
        this.value = value;
    }

    public StackElement getNext() {
        return next;
    }

    public void setNext(StackElement next) {
        this.next = next;
    }

    public int getValue() {
        return value;
    }

    public void setValue(int value) {
        this.value = value;
    }
}
