package other.treeiterator;

import java.util.Iterator;
import java.util.NoSuchElementException;
import java.util.Stack;

public class TreeIterator implements Iterator<String> {
    Stack<TreeNode> stack;

    public TreeIterator(TreeNode node) {
        stack = new Stack<>();
        while (node != null) {
            stack.push(node);
            node = node.getLeft();
        }
    }

    @Override
    public boolean hasNext() {
        return !stack.isEmpty();
    }

    @Override
    public String next() {
        if (hasNext()) {
            TreeNode node = stack.pop();
            String res = node.getValue();
            node = node.getRight();
            while (node != null) {
                stack.push(node);
                node = node.getLeft();
            }
            return res;
        }
        throw new NoSuchElementException("No more elements");
    }
}
