package probetests.probetest2;

public class GameCircle {
    private RingListElement firstElement;
    private RingListElement gameStart;

    public GameCircle() {
        this.firstElement = new RingListElement(null, null);
        firstElement.setNext(firstElement);
        gameStart = firstElement.getNext();
    }

    public GameCircle(String[] names) {
        this();
        for (String s : names) {
            add(s);
        }
        gameStart = firstElement.getNext();
    }

    public void add(String s) {
        firstElement.setPlayer(new Player(s));
        firstElement.setNext(firstElement = new RingListElement(null, firstElement.getNext()));
    }

    public Player play(int var1) {
        return this.isEmpty() ? null : this.play(var1 - 1, this.gameStart);
    }

    private Player play(int runs, RingListElement start) {
        if (runs > 1) {
            if (start.getNext() == firstElement)
                return play(runs, start.getNext());
            return play(runs - 1, start.getNext());
        } else {
            RingListElement removed;
            if (start.getNext().getNext() == start) {//only one element left in circle
                start.getNext().setNext(start.getNext());
                removed = start;
                return removed.getPlayer();
            }
            //more than one element left in circle
            start.setNext(start.getNext().getNext());
            gameStart = start.getNext();
            removed = start.getNext();

            if (gameStart == firstElement)
                gameStart = gameStart.getNext();
            return removed.getPlayer();
        }
    }

    public boolean isEmpty() {
        return firstElement.getNext() == firstElement;
    }

    public String toString() {
        String var1 = "[";
        RingListElement el = firstElement.getNext();
        while (el != firstElement) {
            if (el != gameStart)
                var1 += " " + el.getPlayer().toString();
            else
                var1 += " *" + el.getPlayer().toString() + "*";
            el = el.getNext();
        }

        return var1 + " ]";
    }
}

class RingListElement {
    private Player player;
    private RingListElement next;

    public RingListElement(Player player, RingListElement next) {
        this.player = player;
        this.next = next;
    }

    public Player getPlayer() {
        return player;
    }

    public void setPlayer(Player player) {
        this.player = player;
    }

    public RingListElement getNext() {
        return next;
    }

    public void setNext(RingListElement next) {
        this.next = next;
    }
}
