package vowi.Test2_18S.generator;
//TODO: funktioniert nicht aber ohne angabe weiß ich nicht ganz was ich tun soll
import java.util.*;

/**
 * D1
 * Schreiben bzw. vervollständigen Sie bitte gekennzeichnete Programmteile wie in den Kommentaren beschrieben.
 * Verändern Sie aber nicht vorgegebene Methodenköpfe oder andere vorgegebene Programmteile.
 * Neben den Testfällen in 'main' müssen auch alle Zusicherungen in den Kommentaren und Bedingungen
 * auf dem Aufgabenblatt gelten.
 */

public class PraxisAufgabe {

    /*
    Aufgabe: siehe Angabeblatt

        Ergänzen Sie bitte fehlende Teile der Klassen
        an den mit TODO gekennzeichneten Stellen.
        Auch für teilweise korrekte Lösungen werden Punkte vergeben.

    */

    // 'main' enthält vorgefertigte Testfälle jeweils mit Sollausgabe als Kommentar.
    // Ergänzen weiterer Testfälle ist hier erlaubt.
    // Das Testen wird nicht beurteilt.
    public static void main(String[] args) {

        Generator s = new Range(-5, 5);
        while (s.hasNext()) {
            System.out.print(s.next() + " ");
        }
        System.out.println();
        // -5 -4 -3 -2 -1 0 1 2 3 4 5

        s = new Range(-10, 5);
        FilteredGenerator f = new FilterMultiples(s, 2);

        System.out.println(f.next());
        // -9

        System.out.println(s.next());
        // -8

        FilteredGenerator g = f.copy();
        while (g.hasNext()) {
            System.out.print(g.next() + " ");
        }
        System.out.println();
        // -7 -5 -3 -1 1 3 5

        System.out.println(s.next());
        // -7
        System.out.println(f.next());
        // -5

        try {
            System.out.println(g.next());
        } catch (NoSuchElementException e) {
            System.out.println(e.getMessage());
            // FilterMultiples has no more numbers!
        }

        // Folgende Schleife gibt nur Primzahlen aus (Sieb des Eratosthenes):
        Generator primes = new Range(2, 50);
        while (primes.hasNext()) {
            int prime = primes.next();
            System.out.print(prime + " ");
            primes = new FilterMultiples(primes, prime);
        }
        // 2 3 5 7 11 13 17 19 23 29 31 37 41 43 47
    }
}

// Ein Generator liefert ganze Zahlen. Liefert 'hasNext()' den Wert 'false', ist der Generator verbraucht.
interface Generator {
    // liefert 'true' genau dann, wenn der Generator noch mindestens eine weitere Zahl liefert kann.
    boolean hasNext();

    // liefert die nächste ganze Zahl unter der Vorbedingung, dass 'hasNext()' den Wert 'true' liefert.
    Integer next();

    // liefert eine unabhängige Kopie (tiefe Kopie) des Generators in seinem aktuellen Zustand.
    Generator copy();
}

// Ein Generator, der nur bestimmte Zahlen liefern kann.
// Alle Zahlen 'i', für die 'pass(i)' den Wert 'false' liefert,
// können nicht Element der gelieferten Zahlenfolge sein.
interface FilteredGenerator extends Generator {
    // liefert 'true', wenn 'i' vom Filter durchgelassen wird.
    boolean pass(int i);

    // liefert eine unabhängige Kopie des Generators in seinem aktuellen Zustand.
    FilteredGenerator copy();
}

// 'Range' ist ein Generator der aufsteigenden Folge von aufeinander folgenden ganzen Zahlen im
// bestimmten Intervall von 'first' bis 'last' (inklusive).
// Der Generator liefert nur dann mindestens eine Zahl, wenn gilt first <= last,
// sonst liefert er keine Zahl.
class Range implements Generator {
    private int first;
    private int last;

    public boolean pass(int i) {
        return first <= i && i <= last;
    }

    public Range(int first, int last) {
        this.first = first;
        this.last = last;
    }

    @Override
    public int hashCode() {
        return Objects.hash(first, last);
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null || obj.getClass() != getClass())
            return false;
        if (this == obj)
            return true;
        Range r = (Range) obj;
        return r.first == first && r.last == last;
    }

    @Override
    public String toString() {
        return "[" + first + "-" + last + "]";
    }

    @Override
    public boolean hasNext() {
        return first <= last;
    }

    public Integer next() {
        first++;
        return first - 1;
    }

    @Override
    public Generator copy() {
        return new Range(first, last);
    }
}

// Ein 'FilterMultiples'-Objekt erzeugt aus einer Datenquelle 'source' eine gefilterte Zahlenfolge.
// Alle Zahlen, die durch 'div' teilbar sind, sind nicht Teil der gefilterten Folge.
// Alle übrigen Zahlen von 'source' sind Teil der gefilterten Folge.
// hasNext() und next() beziehen sich auf die gefilterte Folge.
class FilterMultiples implements FilteredGenerator {
    private Range range;
    private int div;

    public FilterMultiples(Generator source, int div) {
        if(source.getClass() == Range.class) {
            range = (Range) source;
            this.div = div;
        }else {
            FilterMultiples fm = (FilterMultiples) source;
            range = fm.range;
            this.div = div;
        }
    }

    @Override
    public boolean pass(int i) {
        return i % div != 0 && range.pass(i);
    }

    @Override
    public FilteredGenerator copy() {
        return new FilterMultiples(range.copy(), div);
    }

    @Override
    public boolean hasNext() {
        return range.hasNext();
    }

    @Override
    public Integer next() {
        if (hasNext()) {
            int i = range.next();
            if (i % div == 0)
                return next();
            return i;
        }
        else
            throw new NoSuchElementException("Ende");
    }
}